﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;

namespace WindowsFormsApplication28
{
	public partial class Form1 : Form, IMessageFilter
	{
		private const int WM_LBUTTONDOWN = 0x0201;
		private const int WM_RBUTTONDOWN = 0x0204;
		private const int WM_MBUTTONDOWN = 0x0207;

		private bool isUsingMessageFilter;

		public Form1()
		{
			try
			{
				Application.AddMessageFilter(this);
				this.isUsingMessageFilter = true;
			}
			catch { }

			InitializeComponent();
		}

		protected override void OnClosed(EventArgs e)
		{
			if (isUsingMessageFilter)
			{
				try
				{
					Application.RemoveMessageFilter(this);
				}
				catch { }
			}
			base.OnClosed(e);
		}

		bool IMessageFilter.PreFilterMessage(ref Message m)
		{
			switch (m.Msg)
			{
				case WM_LBUTTONDOWN:
				case WM_MBUTTONDOWN:
				case WM_RBUTTONDOWN:
					{
						if (this.ultraDockManager1.FlyoutPane != null)
						{
							Control control = Control.FromHandle(m.HWnd);
							while (control != null)
							{
								DockableWindow dockableWindow = control as DockableWindow;
								if (dockableWindow != null && dockableWindow.Pane.IsFlyoutPaneDisplayed)
									return false;

								control = control.Parent;
							}

							this.ultraDockManager1.FlyIn();
						}
					}
					break;
			}

			return false;
		}
	}
}
